﻿/*** Name:      DrawingBox.cs
 *** Created:   9/24/2008, by: Hilkens, RGM
 *** Modified:  10/31/2008, by Hilkens, RGM
 *** Source:    tekenbox.
 *** Copyright: (c) Gr2 Dev 2008
 */
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace sysui
{
    /// <summary>
    /// Eenvoudige klasse voor het tekenen in een Image object dat zichtbaar is in een scrolbaar paneel.
    /// </summary>
    public partial class DrawingBox : UserControl
    {
        private Bitmap img;
    
        /// <summary>
        /// Constructor. Initialiseert de klasse.
        /// </summary>
        public DrawingBox()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Afbeelding voor DrawingBox.
        /// </summary>
        public Bitmap Image
        {
            get { return img; }
            set { img = value; }
        }

        /// <summary>
        /// Berekent de marge tussen afbeelding en paneel.
        /// </summary>
        /// <returns>Een marge.</returns>
        public int GetMargin()
        {
            return (backPanel.Width - backPanel.ClientRectangle.Width) / 2;
        }

        /// <summary>
        /// Stelt een afbeelding in (berekent hoogte/breedte).
        /// </summary>
        public void Publish()
        {
            if (img == null) throw new Exception("Image is null");
            pictureBox.SuspendLayout();
            pictureBox.Width = img.Width;
            pictureBox.Height = img.Height;
            pictureBox.Image = img;
            pictureBox.ResumeLayout();
            pictureBox.Visible = true;
        }

        /// <summary>
        /// Ververst de gehele afbeelding.
        /// </summary>
        public void RefreshImage()
        {
            //Later komt hiervoor een snellere implementatie.
            pictureBox.Refresh();
        }

        /// <summary>
        /// <i>true</i> wanneer scrollbars zichtbaar moeten zijn, anderzijds <i>false</i>.
        /// </summary>
        public bool ScrollBars
        {
            set { backPanel.AutoScroll = value; }
        }

        /// <summary>
        /// Verstuurt een klikgebeurtenis van de ImageBox naar de hoofdklasse.
        /// </summary>
        private void pictureBox_Click(object sender, EventArgs e)
        {
            this.OnClick(e);
        }
    }
}
