﻿/*** Name:      Program.cs
 *** Created:   9/2/2008, by: Hilkens, RGM
 *** Modified:  12/12/2008, by: Hilkens, RGM
 *** Source:    algemene opstartroutines.
 *** Copyright: (c) Gr2 Dev 2008
 */
using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Etaris
{
    /// <summary>
    /// Opstartklasse.
    /// </summary>
    static class Program
    {
        #region Vensters
        /// <summary>
        /// Pauzevenster.
        /// </summary>
        internal static Gui.FrmPause frmPause;
        
        /// <summary>
        /// Speelvenster.
        /// </summary>
        internal static Gui.FrmMain frmMain;
        
        /// <summary>
        /// Instellingenvenster.
        /// </summary>
        internal static Gui.FrmOptions frmOptions;
        
        /// <summary>
        /// Highscore venster.
        /// </summary>
        internal static Gui.FrmHighScores frmHighScores;
        
        /// <summary>
        /// Welkomsvenster.
        /// </summary>
        internal static Gui.FrmWelcome frmWelcome;
        
        /// <summary>
        /// Speelstuktemplatesvenster.
        /// </summary>
        internal static Gui.FrmConfigFile frmConfigFile;

        #endregion

        /// <summary>
        /// Muziekspeler.
        /// </summary>
        internal static Core.MusicPlayer musicPlayer;

        /// <summary>
        /// Opstartroutine.
        /// </summary>
        [STAThread]
        static void Main()
        {
            //Init.
            Core.Settings.LoadSettings("Settings.xml");
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            
            //Laad dialoogvenster. Dialoogvensters zijn altijd geladen.
            frmMain = new Gui.FrmMain();
            frmPause = new Gui.FrmPause();
            frmOptions = new Gui.FrmOptions();
            frmHighScores = new Gui.FrmHighScores();
            frmWelcome = new Gui.FrmWelcome();
            frmConfigFile = new Gui.FrmConfigFile();
            musicPlayer = null;

            //Start het hoofdvenster.
            Application.Run(frmMain);

            //Instellingen opslaan bij het beeindigen van het programma.
            Core.Settings.CurrentSettings.SaveSettings();
        }
    }
}
